function [ Hdec,loop,EN ] = ldpc_dec_TIWBF_layered( r_ch,Nloop,Hrows,Hcols,delta,beta,umbBF,Ngroup,c)
% function [ Hdecoded,loop ] = ldpc_dec_QIMWBF_layered(r_ch,Nloop,Hrows,Hcols,delta,beta,umbBF,Ngroup)
%Initialize variables
bSize = length (r_ch);
[rHR,cHR] = size(Hrows);
[rHC,cHC] = size(Hcols);

% Memory allocation of local arrays
 ymin = zeros(3,rHR);
 parity = zeros(1,rHR);
 En_it = zeros (Ngroup,rHC);
 
%Memory allocation of outputs
 Hdec = zeros(Nloop+1,bSize);
 EN = zeros(4,Nloop*Ngroup); % mitja, maxim

% Hard decision - input determine
 flip = 1.0*(r_ch<0);
 Hdec(1,:)=flip;
  
% yr vector - reliability determine
 yr = beta(2)*(abs(r_ch)>= delta(1)); % hight reliability
 yr(yr==0)= beta(1); % low reliability

% |Y|min-m calc - calc 2 min and pos. saveHdecoded
ymin(:,:) = inf;
for irHR = 1:rHR
     for icHR= 1:cHR 
         if (Hrows(irHR,icHR)==0)
            break;
         end
         if(yr(Hrows(irHR,icHR))<ymin(2,irHR))
             ymin(3,irHR) = ymin(2,irHR); % min 2
             ymin(2,irHR) = yr(Hrows(irHR,icHR));% min 1
             ymin(1,irHR) = Hrows(irHR,icHR);% pos. min 1
         else
             if(yr(Hrows(irHR,icHR))<ymin(3,irHR))
                    ymin(3,irHR) = yr(Hrows(irHR,icHR));% min 2
             end
         end
     end
end

% Loop through all iterations %
for loop = 1:Nloop
    % Loop through all groups %
    for ig=1:Ngroup
        % Check Node Update - syndrome calc
        for irHR = (ig-1)*rHR/Ngroup+1:ig*rHR/Ngroup
            synd = mod(sum(flip(Hrows(irHR,Hrows(irHR,:)~=0))),2);
            for isHR = Hrows(irHR,:)
                if (isHR==ymin(1,irHR))
                    En_it(ig,isHR) = (2*synd-1)*ymin(3,irHR)+beta(2);
                else
                    En_it(ig,isHR) = (2*synd-1)*ymin(2,irHR)+beta(2);
                end
            end
        end
%         if loop==1 && ig<Ngroup
%             continue;
%         end
        En = zeros(1,rHC);
        for iEn = 1:Ngroup
            if iEn==ig
                En = En + En_it(iEn,:);
            else
                En = En + 0.25*En_it(iEn,:);
            end
        end
        plot(En);
        for irHR = 1:rHR
           parity(irHR) = mod(sum(flip(Hrows(irHR,Hrows(irHR,:)~=0))),2);
        end
        % Early exit - if no errors
        if (sum(parity)==0)
            for il = loop:Nloop
               Hdec(il+1,:)=flip;
            end
            break;
        end
        % Energy
        En_er = En(flip~=c);
        En_ok = En(flip==c);
        EN(1,(loop-1)*Ngroup+ig) = mean(En_ok(:));
        EN(2,(loop-1)*Ngroup+ig) = var(En_ok(:));
        EN(3,(loop-1)*Ngroup+ig) = mean(En_er(:));
        EN(4,(loop-1)*Ngroup+ig) = var(En_er(:));
        % Bit flipping
%         ibFlip= find(En>=umbBF((loop-1)*Ngroup+ig));
        ibFlip= find(En>=umbBF(loop));
        flip(ibFlip)=not(flip(ibFlip));
    end
    % Early exit - if no errors
    if (sum(parity)==0)
        break;
    end
    % Hard decode 
    Hdec(loop+1,:) = flip; 
end