function [ Hdec,loop,En_sub_it,EN ] = ldpc_dec_TIWBF_layered_hw( r_ch,Nloop,Hrows,Hcols,delta,beta,umbBF,Ngroup,c)
% function [ Hdecoded,loop ] = ldpc_dec_QIMWBF_layered(r_ch,Nloop,Hrows,Hcols,delta,beta,umbBF,Ngroup)
%Initialize variables
bSize = length (r_ch);
[rHR,cHR] = size(Hrows);
[rHC,cHC] = size(Hcols);

% Memory allocation of local arrays
 ymin = zeros(3,rHR);
 parity = zeros(1,rHR);
 En_it = zeros (Ngroup,rHC);
 
%Memory allocation of outputs
 Hdec = zeros((Nloop+1)*Ngroup,bSize);
 En_test = zeros(1,rHC);
 En_test_Q = zeros(1,rHC);
 EN = zeros(4,Nloop*Ngroup); % mitja, maxim
 En_sub_it = zeros((Nloop+1)*Ngroup,rHC); % mitja, maxim
 
% Hard decision - input determine
 flip = 1.0*(r_ch<0);
 Hdec(1,:)=flip;
  
% yr vector - reliability determine
 yr = beta(2)*(abs(r_ch)>= delta(1)); % hight reliability
 yr(yr==0)= beta(1); % low reliability
% yr vector - beta 0 or 1
%  Yr = 1*(abs(r_ch)>= delta(1)); % hight reliability

% En quantize
 Q = [7 3]; % quantize (8,7 ** 7,6 ** 6,5 ** 0,0) 
 q = quantizer('ufixed', Q);
 % En quantize
%  Q1 = [4 1]; % quantize En_calc
%  q1 = quantizer('ufixed', Q1);

% |Y|min-m calc - calc 2 min and pos. saveHdecoded
ymin(:,:) = inf;
for irHR = 1:rHR
     for icHR= 1:cHR 
         if (Hrows(irHR,icHR)==0)
            break;
         end
         if(yr(Hrows(irHR,icHR))<ymin(2,irHR))
             ymin(3,irHR) = ymin(2,irHR); % min 2
             ymin(2,irHR) = yr(Hrows(irHR,icHR));% min 1
             ymin(1,irHR) = Hrows(irHR,icHR);% pos. min 1
         else
             if(yr(Hrows(irHR,icHR))<ymin(3,irHR))
                    ymin(3,irHR) = yr(Hrows(irHR,icHR));% min 2
             end
         end
     end
end
% Choose TNU: mod(irHR,4)== [1 2 3 0] or  mod(irHR,64)== [1 2 3 ... 62 63 0]
TNU_N = 1;
% Inputs id_lnold for each TNU (1 to rHC/Ngroup=384/6=64 or rHC/Ngroup=16/4=4)
if (rHC == 24)
    resultspath = 'Test_matrix/';
else
    resultspath = 'RSBased/';
end
% mkdir (['seed [' num2str(seed) ']_E [' num2str(EbNodB) ']']);
% resultspath = ['seed [' num2str(seed) ']_E [' num2str(EbNodB) ']'];
% [id0]= fopen (['./' resultspath 'id_zn.txt'],'w');
f_id = fopen(['../stm/' resultspath 't_id_lnold_zeros_tnu(1).txt'],'w');
f_id_1 = fopen('../stm/RSBased/t_id_lnold_zeros_tnu(1).txt','w');
f_od = fopen(['../stm/' resultspath 't_od_lnnew_zeros_tnu(' num2str(TNU_N) ').txt'],'w');
f_od_decn = fopen(['../stm/' resultspath 't_od_decn_zeros_tnu(' num2str(TNU_N) ').txt'],'w');
f_od_synd = fopen(['../stm/' resultspath 't_od_synd_zeros_tnu(' num2str(TNU_N) ').txt'],'w');
f_od_wmn = fopen(['../stm/' resultspath 't_od_wmn_zeros_tnu(' num2str(TNU_N) ').txt'],'w');
f_od_En_calc = fopen(['../stm/' resultspath 't_od_En_calc_zeros_tnu(' num2str(TNU_N) ').txt'],'w');
% f_id = fopen('../stm/RSBased/t_id_lnold_zeros_tnu(1).txt','w');
% f_od = fopen('../stm/RSBased/t_od_lnnew_zeros_tnu(1).txt','w');
% f_od_decn = fopen('../stm/RSBased/t_od_decn_zeros_tnu(1).txt','w');
% f_od_synd = fopen('../stm/RSBased/t_od_synd_zeros_tnu(1).txt','w');
% f_od_wmn = fopen('../stm/RSBased/t_od_wmn_zeros_tnu(1).txt','w');
% f_od_En_calc = fopen('../stm/RSBased/t_od_En_calc_zeros_tnu(1).txt','w');

% Loop through all iterations %
for loop = 1:Nloop
    % Loop through all groups %
    for ig=1:Ngroup
        % Check Node Update - syndrome calc
%         En_test = zeros(1,rHC);
        for irHR = (ig-1)*rHR/Ngroup+1:ig*rHR/Ngroup
            synd = mod(sum(flip(Hrows(irHR,Hrows(irHR,:)~=0))),2); 
            if mod(irHR,rHR/Ngroup)==TNU_N % mod(irHR,4)== [1 2 3 0]
                display(['loop = ' num2str(loop) ' ig = ' num2str(ig)]);
                display(['En_sub_it_old = ' num2str(En_it(ig,Hrows(irHR,:)))]);
                display(['En_old = ' num2str(En_test(Hrows(irHR,:)))]);
            end
            % Outputs od_wmn & od_En_calc for each TNU (1 to rHC/Ngroup=384/6=64 or rHC/Ngroup=16/4=4)
            for isHR = Hrows(irHR,:)
                if (isHR==ymin(1,irHR))
                    En_it(ig,isHR) = (2*synd-1)*ymin(3,irHR)+beta(2);
                    En_test(isHR) = 0.25*(En_test(isHR)) + En_it(ig,isHR);
                    En_test_Q(isHR) = quantize(q,En_test(isHR));
                    if mod(irHR,rHR/Ngroup)==TNU_N
                       fprintf (f_od_wmn,'%s',dec2bin(1*(ymin(3,irHR) == beta(2))));
                       fprintf (f_od_En_calc,'%\t',num2bin(q1,En_it(ig,isHR)));
                    end
                else
                    En_it(ig,isHR) = (2*synd-1)*ymin(2,irHR)+beta(2);
                    En_test(isHR) = 0.25*(En_test(isHR)) + En_it(ig,isHR);
                    En_test_Q(isHR) = quantize(q,En_test(isHR));
                    if mod(irHR,rHR/Ngroup)==TNU_N
                       fprintf (f_od_wmn,'%s',dec2bin(1*(ymin(2,irHR) == beta(2))));
                       fprintf (f_od_En_calc,'%s\t',num2bin(q1,En_it(ig,isHR)));
                    end
                end
            end
            % Inputs id_lnold for each TNU (1 to rHC/Ngroup=384/6=64 or rHC/Ngroup=16/4=4)
            if mod(irHR,rHR/Ngroup)==TNU_N
                fprintf (f_od_synd,'%s\n',dec2bin(synd));
                fprintf (f_od_wmn,'\n');
                fprintf (f_od_En_calc,'\n');
                for iC = Hrows(irHR,Hrows(irHR,:)~=0)
                    fprintf (f_id, num2bin(q,En(iC)));    
                    fprintf (f_id,'%s',dec2bin(flip(iC)));
                    fprintf (f_id,'%s\t',dec2bin(Yr(iC)));
                end
                fprintf(f_id,'\n');
            end
        end       
%         if loop==1 && ig<Ngroup
%             continue;
%         end
%         plot(En);
        for irHR = 1:rHR
           parity(irHR) = mod(sum(flip(Hrows(irHR,Hrows(irHR,:)~=0))),2);
        end
        % Early exit - if no errors
        if (sum(parity)==0)
            for il = loop:Nloop
               Hdec(il+1,:)=flip;
            end
            break;
        end
        % Energy
        En_er = En_test(flip~=c);
        En_ok = En_test(flip==c);
%         subplot(2,1,1), plot(En_er);
%         subplot(2,1,2), plot(En_ok);
        EN(1,(loop-1)*Ngroup+ig) = mean(En_ok(:));
        EN(2,(loop-1)*Ngroup+ig) = var(En_ok(:));
        EN(3,(loop-1)*Ngroup+ig) = mean(En_er(:));
        EN(4,(loop-1)*Ngroup+ig) = var(En_er(:));
        En_sub_it(loop*Ngroup+ig,:) = En_test;
        % Bit flipping
%         ibFlip= find(En>=umbBF((loop-1)*Ngroup+ig));
        ibFlip= find(En_test>=umbBF(loop));
        flip(ibFlip)=not(flip(ibFlip));
        % Hard decode 
        Hdec(loop*Ngroup+ig,:) = flip;
        % Outputs od_lnnew for each TNU (1 to rHC/Ngroup=384/6=64 or rHC/Ngroup=16/4=4)
        for irHR = (ig-1)*rHR/Ngroup+1:ig*rHR/Ngroup
            if mod(irHR,rHR/Ngroup)==TNU_N
                display(['En_sub_it_new = ' num2str(En_it(ig,Hrows(irHR,:)))]);
                display(['En_new = ' num2str(En_test(Hrows(irHR,:)))]);
                display(['En_n_Q = ' num2str(En_test_Q(Hrows(irHR,:)))]);
                pause;
                clc;
                for iC = Hrows(irHR,Hrows(irHR,:)~=0)
                    fprintf (f_od, num2bin(q,En(iC)));
                    fprintf (f_od,'%s',dec2bin(flip(iC)));
                    fprintf (f_od,'%s\t',dec2bin(Yr(iC)));
                    fprintf (f_od_decn,'%s',dec2bin(flip(iC)));
                end
                fprintf(f_od,'\n');
                fprintf(f_od_decn,'\n');
            end
        end
    end
    % Early exit - if no errors
    if (sum(parity)==0)
        break;
    end
    % Hard decode 
    Hdec(loop+1,:) = flip;
    fclose(f_id);
    fclose(f_od);
    fclose(f_od_decn);
end